#ifndef CoCoA_MinPoly_H
#define CoCoA_MinPoly_H

//   Copyright (c)  2016  Anna M. Bigatti

//   This file is part of the source of CoCoALib, the CoCoA Library.

//   CoCoALib is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.

//   CoCoALib is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with CoCoALib.  If not, see <http://www.gnu.org/licenses/>.


// Header file for functions MinPoly etc.

#include <iosfwd>
// using std::ostream;
#include <vector>
// using std::vector;

namespace CoCoA
{

  class RingElemAlias;    // fwd decl -- defined in ring.H
  //  class ConstRefRingElem; // fwd decl -- defined in ring.H
  class ConstMatrixView;  // fwd decl -- defined in matrix.H
  class RingElem;         // fwd decl -- defined in ring.H

  RingElem MinPoly(ConstMatrixView M, ConstRefRingElem x);
  RingElem MinPoly(ConstRefRingElem f, ConstRefRingElem x);

  RingElem MinPolyMat(ConstRefRingElem f, ConstRefRingElem x);
  RingElem MinPolyDef(ConstRefRingElem f, ConstRefRingElem x);
  RingElem MinPolyElim(ConstRefRingElem f, ConstRefRingElem x);

  // to be deleted later on
  RingElem MinPolyMat(ConstRefRingElem f, const ideal& I, ConstRefRingElem x);
  RingElem MinPolyDef(ConstRefRingElem f, const ideal& I, ConstRefRingElem x);
  RingElem MinPolyElim(ConstRefRingElem f, const ideal& I, ConstRefRingElem x);
  

} // end of namespace CoCoA



// RCS header/log in the next few lines
// $Header: /Volumes/Home_1/cocoa/cvs-repository/CoCoALib-0.99/include/CoCoA/MinPoly.H,v 1.1 2016/03/18 11:54:00 bigatti Exp $
// $Log: MinPoly.H,v $
// Revision 1.1  2016/03/18 11:54:00  bigatti
// -- first import
//

#endif
